import * as l from "vue";
import { t as X } from "@opentiny/vue-locale";
function ee(i, e) {
  var t = Object.keys(i);
  if (Object.getOwnPropertySymbols) {
    var n = Object.getOwnPropertySymbols(i);
    e && (n = n.filter(function(o) {
      return Object.getOwnPropertyDescriptor(i, o).enumerable;
    })), t.push.apply(t, n);
  }
  return t;
}
function O(i) {
  for (var e = 1; e < arguments.length; e++) {
    var t = arguments[e] != null ? arguments[e] : {};
    e % 2 ? ee(Object(t), !0).forEach(function(n) {
      ie(i, n, t[n]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(i, Object.getOwnPropertyDescriptors(t)) : ee(Object(t)).forEach(function(n) {
      Object.defineProperty(i, n, Object.getOwnPropertyDescriptor(t, n));
    });
  }
  return i;
}
function be(i, e) {
  if (typeof i != "object" || !i)
    return i;
  var t = i[Symbol.toPrimitive];
  if (t !== void 0) {
    var n = t.call(i, e || "default");
    if (typeof n != "object")
      return n;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (e === "string" ? String : Number)(i);
}
function Ce(i) {
  var e = be(i, "string");
  return typeof e == "symbol" ? e : String(e);
}
function S(i) {
  "@babel/helpers - typeof";
  return S = typeof Symbol == "function" && typeof Symbol.iterator == "symbol" ? function(e) {
    return typeof e;
  } : function(e) {
    return e && typeof Symbol == "function" && e.constructor === Symbol && e !== Symbol.prototype ? "symbol" : typeof e;
  }, S(i);
}
function ie(i, e, t) {
  return e = Ce(e), e in i ? Object.defineProperty(i, e, {
    value: t,
    enumerable: !0,
    configurable: !0,
    writable: !0
  }) : i[e] = t, i;
}
function te(i) {
  return xe(i) || Ae(i) || $e(i) || Pe();
}
function xe(i) {
  if (Array.isArray(i))
    return H(i);
}
function Ae(i) {
  if (typeof Symbol < "u" && i[Symbol.iterator] != null || i["@@iterator"] != null)
    return Array.from(i);
}
function $e(i, e) {
  if (i) {
    if (typeof i == "string")
      return H(i, e);
    var t = Object.prototype.toString.call(i).slice(8, -1);
    if (t === "Object" && i.constructor && (t = i.constructor.name), t === "Map" || t === "Set")
      return Array.from(i);
    if (t === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t))
      return H(i, e);
  }
}
function H(i, e) {
  (e == null || e > i.length) && (e = i.length);
  for (var t = 0, n = new Array(e); t < e; t++)
    n[t] = i[t];
  return n;
}
function Pe() {
  throw new TypeError(`Invalid attempt to spread non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`);
}
function Q(i) {
  var e = /* @__PURE__ */ Object.create(null);
  return function(n) {
    var o = e[n];
    return o || (e[n] = i(n));
  };
}
var we = /-(\w)/g, Oe = Q(function(i) {
  return i.replace(we, function(e, t) {
    return t ? t.toUpperCase() : "";
  });
}), je = Q(function(i) {
  return i.charAt(0).toUpperCase() + i.slice(1);
}), Ie = /\B([A-Z])/g, Ee = Q(function(i) {
  return i.replace(Ie, "-$1").toLowerCase();
}), W = function() {
  var e = {}, t = function(r, a) {
    var u = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : !1;
    if (r && typeof r == "string" && typeof a == "function") {
      var c = e[r] || [];
      e[r] = c, c.push(a), a.once = u;
    }
  }, n = {
    emit: function(r) {
      var a = arguments, u = e[r];
      u && (u.forEach(function(c) {
        return c.apply(null, [].slice.call(a, 1));
      }), e[r] = u.filter(function(c) {
        return !c.once;
      }));
    },
    on: t,
    once: function(r, a) {
      t(r, a, !0);
    },
    off: function(r, a) {
      if (r && typeof r == "string") {
        var u = e[r];
        typeof a == "function" ? e[r] = u.filter(function(c) {
          return c !== a;
        }) : delete e[r];
      } else
        e = {};
    }
  };
  return n;
}, Se = function(e) {
  var t = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, n = {};
  for (var o in e)
    o.indexOf("_") !== 0 && (n[o] = e[o]);
  for (var r in t)
    n[r] = t[r];
  return n;
}, Te = function(e, t) {
  if (!(!e || !t)) {
    var n = [];
    typeof e == "string" ? n.push(e) : Array.isArray(e) && (n = e);
    var o = [];
    typeof t == "string" ? o.push(t) : Array.isArray(t) && (o = t);
    var r = [];
    return o.forEach(function(a) {
      return n.forEach(function(u) {
        return r.push("".concat(a, ":").concat(u, "-").concat(a));
      });
    }), n.concat(r).join(" ");
  }
}, _e = function() {
  var e = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, t = arguments.length > 1 ? arguments[1] : void 0;
  if (S(t) === "object") {
    var n = Array.isArray(t) ? t : Object.keys(t).filter(function(r) {
      return t[r];
    }), o = "";
    return n.forEach(function(r) {
      e[r] && (o += "".concat(e[r], " "));
    }), o;
  } else
    return e[t] || "";
}, wt = l.Teleport, oe = l.defineAsyncComponent, Me = l.markRaw, ae = function(e) {
  var t = e.view, n = t === void 0 ? void 0 : t, o = e.component, r = o === void 0 ? void 0 : o, a = e.props, u = e.context, c = u.attrs, s = u.slots, f = e.extend, v = f === void 0 ? {} : f;
  return function() {
    return l.h(n && n.value || r, O(O(O({
      ref: "modeTemplate"
    }, a), c), v), s);
  };
}, Z = function(e) {
  var t = l.getCurrentInstance();
  return e && ce(t), t == null ? void 0 : t.appContext.config.globalProperties;
}, Re = function() {
  var e, t = l.getCurrentInstance(), n = t == null || (e = t.type) === null || e === void 0 ? void 0 : e.name;
  if (!n) {
    var o, r;
    n = t == null || (o = t.parent) === null || o === void 0 || (r = o.type) === null || r === void 0 ? void 0 : r.name;
  }
  return n || "";
}, ke = function() {
  var e;
  return ((e = l.getCurrentInstance()) === null || e === void 0 ? void 0 : e.appContext) || {
    component: function() {
    }
  };
}, Ve = function() {
  var e = l.getCurrentInstance();
  return (e == null ? void 0 : e.appContext.config.globalProperties) || {};
}, ue = function() {
  var e = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : l.getCurrentInstance(), t = e == null ? void 0 : e.appContext.config.globalProperties.$router, n = t && t.currentRoute.value;
  return {
    route: n,
    router: t
  };
}, ce = function(e) {
  var t = W();
  typeof e.$emitter > "u" && Object.defineProperty(e, "$emitter", {
    get: function() {
      return t;
    }
  });
}, Ke = function(e) {
  var t = function(o, r, a, u) {
    var c = o.subTree && o.subTree.children || o.children;
    Array.isArray(c) && c.forEach(function(s) {
      var f = s.type && s.type.componentName, v = s.component;
      f === r ? (v.emit(a, u), v.$emitter && v.$emitter.emit(a, u)) : t(s, r, a, u);
    });
  };
  return {
    dispatch: function(o, r, a) {
      for (var u = e.parent || e.root, c = u.type && u.type.componentName; u && (!c || c !== o); )
        u = u.parent, u && (c = u.type && u.type.componentName);
      if (u) {
        var s, f;
        (s = u).emit.apply(s, te([r].concat(a))), u.$emitter && (f = u.$emitter).emit.apply(f, te([r].concat(a)));
      }
    },
    broadcast: function(o, r, a) {
      t(e, o, r, a);
    }
  };
}, U = function(e) {
  if (e && e.parent)
    return e.parent.type.name === "AsyncComponentWrapper" && e.parent.parent ? e.parent.parent : e.parent;
}, Le = function(e) {
  return function(t) {
    var n = U(e), o = 0, r = function(u) {
      return {
        level: o,
        vm: E({}, u),
        el: u.vnode.el,
        options: u.type
      };
    };
    if (typeof t != "function")
      return n ? r(n) : {};
    for (o++; n && !t(r(n)); )
      n = U(n), o++;
  };
}, Ue = function(e) {
  return function(t) {
    if (typeof t != "function")
      return fe(e.subTree);
    var n = 1, o = function r(a) {
      if (a) {
        var u = a.children || a.dynamicChildren, c = n++;
        if (Array.isArray(u)) {
          if (u.some(function(s) {
            return s.component && t({
              level: c,
              vm: E({}, s.component),
              el: s.el,
              options: s.type,
              isLevel1: !0
            });
          }))
            return;
          u.forEach(function(s) {
            return r(s);
          });
        }
      }
    };
    o(e.subTree);
  };
}, Be = /^on[A-Z]/, Ne = function(e) {
  var t = {}, n = {};
  for (var o in e) {
    var r = e[o];
    if (Be.test(o) && typeof r == "function") {
      n[Ee(o.substr(2))] = r;
      continue;
    }
    t[o] = r;
  }
  return {
    $attrs: t,
    $listeners: n
  };
}, fe = function(e) {
  var t = [];
  if (t.refs = {}, e) {
    var n = e.dynamicChildren || e.children;
    Array.isArray(n) ? n.forEach(function(o) {
      if (o.component) {
        var r = E({}, o.component);
        t.push(r), o.props.ref && (t.refs[o.props.ref] = r);
      }
    }) : e.component && t.push(E({}, e.component));
  }
  return t;
}, F = function(e, t, n, o) {
  var r = function(c) {
    if (typeof o == "function" && o(c))
      return 1;
    Object.defineProperty(e, c, {
      configurable: !0,
      enumerable: !0,
      get: function() {
        return t[n][c];
      },
      set: function(f) {
        return t[n][c] = f;
      }
    });
  };
  for (var a in t[n])
    r(a);
  return e;
}, ne = function(e) {
  return e.indexOf("_") === 0;
}, se = function(e, t) {
  return F(e, t, "setupState", null), F(e, t, "props", ne), F(e, t, "ctx", ne), e;
}, E = function i(e, t) {
  var n = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : null, o = Ne(t.attrs), r = o.$attrs, a = o.$listeners, u = t.$emitter;
  u || (ce(t), u = t.$emitter);
  var c = function() {
    for (var v = arguments.length, h = new Array(v), p = 0; p < v; p++)
      h[p] = arguments[p];
    t.emit.apply(t, h), u.emit.apply(e, h);
  }, s = function(v, h, p) {
    return v[h] = p;
  };
  return n || se(e, t), Object.defineProperties(e, {
    $attrs: {
      get: function() {
        return r;
      }
    },
    $children: {
      get: function() {
        return fe(t.subTree);
      }
    },
    $constants: {
      get: function() {
        return t.props._constants;
      }
    },
    $emit: {
      get: function() {
        return c;
      }
    },
    $el: {
      get: function() {
        return t.vnode.el;
      }
    },
    $listeners: {
      get: function() {
        return a;
      }
    },
    $mode: {
      get: function() {
        return t._tiny_mode;
      }
    },
    $nextTick: {
      get: function() {
        return l.nextTick;
      }
    },
    $off: {
      get: function() {
        return u.off;
      }
    },
    $on: {
      get: function() {
        return u.on;
      }
    },
    $once: {
      get: function() {
        return u.once;
      }
    },
    $options: {
      get: function() {
        return {
          componentName: t.type.componentName
        };
      }
    },
    $parent: {
      get: function() {
        return t.parent && i({}, U(t));
      }
    },
    $refs: {
      get: function() {
        return t.refs;
      }
    },
    $renderless: {
      get: function() {
        return t.props.tiny_renderless;
      }
    },
    $scopedSlots: {
      get: function() {
        return t.slots;
      }
    },
    $set: {
      get: function() {
        return s;
      }
    },
    $slots: {
      get: function() {
        return t.slots;
      }
    },
    $template: {
      get: function() {
        return t.props.tiny_template;
      }
    }
  }), e;
}, Fe = function(e, t) {
  for (var n in e.refs)
    Object.prototype.hasOwnProperty.call(e.refs, n) && (t[n] = e.refs[n]);
}, Ge = function(e, t) {
  var n, o, r = l.getCurrentInstance(), a = r == null ? void 0 : r.appContext.config.globalProperties, u = ue(r), c = u.route, s = u.router, f = r == null || (n = r.proxy) === null || n === void 0 || (o = n.$root) === null || o === void 0 ? void 0 : o.$i18n, v = Ke(r), h = v.dispatch, p = v.broadcast, w = Le(r), $ = Ue(r), b = E({}, r, e), d = e.emit, g = {}, C = typeof r.props.tiny_template > "u" && U(r), m = C ? E({}, C) : r.parent ? E({}, r.parent) : null, y = function(A) {
    var P, T = A.name, V = A.value, K = C ? C.ctx : r == null || (P = r.parent) === null || P === void 0 ? void 0 : P.ctx;
    K[T] = V, m[T] = V;
  }, x = function(A) {
    Object.defineProperties(b, A), Object.defineProperties(r == null ? void 0 : r.ctx, A);
  }, M = function(A) {
    m && Object.defineProperties(m, A);
  };
  return l.onBeforeMount(function() {
    return se(b, r);
  }), l.onMounted(function() {
    return Fe(r, g);
  }), {
    framework: "vue3",
    vm: b,
    emit: d,
    emitter: W,
    route: c,
    router: s,
    dispatch: h,
    broadcast: p,
    parentHandler: w,
    childrenHandler: $,
    i18n: f,
    refs: g,
    slots: r == null ? void 0 : r.slots,
    scopedSlots: r == null ? void 0 : r.slots,
    attrs: e.attrs,
    parent: m,
    nextTick: l.nextTick,
    constants: r == null ? void 0 : r.props._constants,
    mode: t,
    isPCMode: t === "pc",
    isMobileMode: t === "mobile",
    service: a == null ? void 0 : a.$service,
    getService: function() {
      return a == null ? void 0 : a.$getService(b);
    },
    setParentAttribute: y,
    defineInstanceProperties: x,
    defineParentInstanceProperties: M
  };
}, G = function(e, t, n) {
  if (typeof e[t] < "u") {
    var o = e[t];
    e[n] = function(r, a, u) {
      u.context = a.instance, o(r, a, u);
    }, delete e[t];
  }
}, He = function(e) {
  for (var t in e) {
    var n = e[t];
    G(n, "bind", "beforeMount"), G(n, "update", "updated"), G(n, "unbind", "unmounted");
  }
  return e;
}, ze = function(e) {
  return e;
}, De = l.Text, qe = l.Comment, Qe = function(e) {
  return !e || !e.type || [De, qe].includes(e.type);
}, We = function(e) {
  var t = {};
  for (var n in e)
    if (n === "class" || n === "style")
      t[n] = e[n];
    else if (n === "on" || n === "nativeOn") {
      var o = e[n];
      for (var r in o)
        t["on".concat(je(Oe(r)))] = o[r];
    } else if (n === "attrs" || n === "props" || n === "domProps") {
      var a = e[n];
      for (var u in a)
        t[u] = a[u];
    } else
      t[n] = e[n];
  return t;
}, Ze = function(e) {
  var t = e, n = !1;
  if (typeof e == "string" && typeof document < "u") {
    var o = document.createElement(e), r = ["SVG", "CIRCLE", "PATH"];
    o instanceof HTMLUnknownElement && !r.includes(o.nodeName) || e.includes("-") ? (e = e.toLowerCase(), n = !0, e === "transition" ? t = l.Transition : e === "transition-group" ? t = l.TransitionGroup : t = l.resolveComponent(e)) : t = e;
  }
  return {
    type: t,
    component: e,
    customElement: n
  };
}, Ye = function(e, t, n) {
  var o = {}, r = n, a = Ze(e), u = a.customElement, c = a.type;
  return e = a.component, t && S(t) === "object" && !Array.isArray(t) ? (o = We(t), t.scopedSlots && (r = t.scopedSlots)) : (typeof t == "string" || Array.isArray(t)) && (n = t), (typeof n == "string" || Array.isArray(n)) && (r = typeof e != "string" || u ? function() {
    return n;
  } : n), l.h(c, o, r);
}, Je = function(e) {
  return function(t) {
    var n = t.component, o = t.propsData, r = t.el, a = Object.assign(n, {
      provide: ie({}, e.configKey, e.configInstance)
    }), u = l.createVNode(a, o);
    return l.render(u, r), E({}, u.component);
  };
}, Xe = l.defineComponent, le = !1, Ot = !0, et = l.isVNode, jt = l.KeepAlive, z = function(e) {
  var t = [];
  return Object.keys(e).forEach(function(n) {
    return e[n] && t.push(n);
  }), t.join(" ");
}, tt = function(e) {
  var t = [];
  return e.forEach(function(n) {
    typeof n == "string" ? t.push(n) : S(n) === "object" && t.push(z(n));
  }), t.join(" ");
}, D = function(e) {
  if (!e)
    return "";
  if (typeof e == "string")
    return e;
  if (Array.isArray(e) && e.length > 0) {
    var t = [];
    return e.forEach(function(n) {
      n && (typeof n == "string" ? t.push(n) : Array.isArray(n) ? t.push(tt(n)) : S(n) === "object" && t.push(z(n)));
    }), t.join(" ");
  }
  return S(e) === "object" ? z(e) : "";
}, It = function(e) {
  var t = D(e), n = Array.from(new Set(t.split(" "))).filter(function(o) {
    return o;
  });
  return D(n);
};
var nt = typeof window > "u";
function re(i, e, t, n) {
  var o, r = 0;
  typeof e != "boolean" && (n = t, t = e, e = void 0);
  function a() {
    var c = this, s = (/* @__PURE__ */ new Date()).valueOf() - r, f = arguments;
    function v() {
      r = (/* @__PURE__ */ new Date()).valueOf(), t.apply(c, f);
    }
    function h() {
      o = void 0;
    }
    n && !o && v(), o && clearTimeout(o);
    var p = n === void 0;
    p && s > i ? v() : e !== !0 && (o = setTimeout(n ? h : v, p ? i - s : i));
  }
  function u() {
    o && (clearTimeout(o), o = null);
  }
  return a._cancel = u, a;
}
function rt(i, e, t) {
  return t === void 0 ? re(i, e, !1) : re(i, t, e !== !1);
}
var it = function() {
  if (!nt) {
    var e = l.ref(""), t = ["2xl", "xl", "lg", "md", "sm"], n = {
      "2xl": window.matchMedia("(min-width:1536px)"),
      xl: window.matchMedia("(min-width:1280px)"),
      lg: window.matchMedia("(min-width:1024px)"),
      md: window.matchMedia("(min-width:768px)"),
      sm: window.matchMedia("(min-width:640px)")
    }, o = function() {
      for (var u = 0; u < t.length; u++) {
        var c = t[u];
        if (n[c].matches) {
          e.value = c;
          return;
        }
      }
      e.value = "default";
    }, r = rt(0, function() {
      return o();
    });
    return o(), t.forEach(function(a) {
      return n[a].addEventListener("change", r);
    }), l.onBeforeUnmount(function() {
      t.forEach(function(a) {
        return n[a].removeEventListener("change", r);
      });
    }), {
      current: e
    };
  }
};
function Et() {
  var i = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : 100, e = l.ref(0), t;
  function n() {
    t = requestAnimationFrame(function() {
      e.value++, !(e.value >= i) && n();
    });
  }
  function o() {
    t && (cancelAnimationFrame(t), t = 0);
  }
  return n(), l.onBeforeUnmount(function() {
    return o();
  }), {
    defer: function(a) {
      return e.value >= a;
    },
    reset: function() {
      o(), e.value = 0, n();
    },
    cancel: o
  };
}
var ot = ["IconLoadingShadow", "IconNoData"], ve = 0, at = function i(e, t) {
  {
    var n;
    if ((n = e.props) !== null && n !== void 0 && n.id) {
      var o = "".concat(e.props.id).concat(ve);
      t[e.props.id] = o, e.props.id = o;
    }
  }
  Array.isArray(e == null ? void 0 : e.children) && e.children.forEach(function(r) {
    i(r, t);
  });
}, ut = function i(e, t) {
  var n = ["fill", "mask", "filter"];
  n.forEach(function(o) {
    {
      var r, a;
      if ((r = e.props) !== null && r !== void 0 && (a = r[o]) !== null && a !== void 0 && a.includes("url(#")) {
        var u = e.props[o].replace("url(#", "").replace(")", ""), c = t[u];
        c && (e.props[o] = "url(#".concat(c, ")"));
      }
    }
  }), Array.isArray(e == null ? void 0 : e.children) && e.children.forEach(function(o) {
    i(o, t);
  });
}, ct = function(e) {
  if (e) {
    var t = {};
    at(e, t), ut(e, t), ve++;
  }
}, ft = function(e) {
  var t = e.getCurrentInstance, n = e.isVue2, o = e.nextTick, r = e.onUnmounted;
  return function() {
    var a = t().proxy;
    n || Object.defineProperty(a, "$scopedSlots", {
      configurable: !0,
      value: null
    }), Object.defineProperty(a, "instanceSlots", {
      configurable: !0,
      get: function() {
        return a.$scopedSlots || a.$slots;
      }
    }), r(function() {
      o(function() {
        n || delete a.$scopedSlots, delete a.instanceSlots;
      });
    });
  };
}, st = function() {
}, lt = function(e) {
  var t = e.onMounted, n = e.onActivated, o = e.nextTick;
  return function(r) {
    var a;
    t(function() {
      r(), o(function() {
        return a = !0;
      });
    }), n(function() {
      return a && r();
    });
  };
}, vt = function(e) {
  var t = e.computed, n = e.getCurrentInstance, o = e.inject, r = e.markRaw, a = e.nextTick, u = e.onMounted, c = e.onActivated, s = e.onUnmounted, f = e.provide, v = e.reactive, h = e.toRef;
  return function() {
    var p = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {}, w = p.relationKey, $ = p.relationContainer, b = p.onChange, d = p.childrenKey, g = p.delivery;
    if (!w)
      throw new Error("[TINY Error]<relationKey> must exist.");
    var C = n(), m = v({
      children: [],
      indexInParent: -1
    }), y = o(w, null), x = [];
    if (y) {
      var M = y.link, j = y.unlink, A = y.callbacks, P = y.childrenKey, T = y.delivery;
      x = A, d = d || P || "instanceChildren", g = T, m.indexInParent = M(C), s(function() {
        return j(C);
      });
    } else {
      d = d || "instanceChildren";
      var V = lt({
        onMounted: u,
        onActivated: c,
        nextTick: a
      }), K = b ? function() {
        return a(b);
      } : st, R;
      a(function() {
        var I = typeof $ == "function" ? $() : $;
        I && (R = new MutationObserver(function(k, _) {
          var J = [];
          pt(I.childNodes, J), x.forEach(function(he) {
            return he(J, k, _);
          }), K();
        }), R.observe(I, {
          attributes: !0,
          childList: !0,
          subtree: !0
        }));
      }), V(function() {
        return K();
      }), s(function() {
        R && (R.disconnect(), R = null), x = null;
      });
    }
    var ge = function(k) {
      var _ = k.proxy;
      return m.children.push(r(_)), t(function() {
        return m.children.indexOf(_);
      });
    }, ye = function(k) {
      var _ = m.children.indexOf(k.proxy);
      _ > -1 && m.children.splice(_, 1);
    };
    return x.push(function(I) {
      return dt(m.children, I);
    }), f(w, {
      link: ge,
      unlink: ye,
      callbacks: x,
      childrenKey: d,
      delivery: g
    }), Object.defineProperty(C.proxy, d, {
      configurable: !0,
      get: function() {
        return m.children;
      }
    }), s(function() {
      return delete C.proxy[d];
    }), {
      children: h(m, "children"),
      index: h(m, "indexInParent"),
      delivery: g
    };
  };
}, pt = function i(e, t) {
  e.length && e.forEach(function(n) {
    t.push(n), n.childNodes && i(n.childNodes, t);
  });
}, dt = function(e, t) {
  e.sort(function(n, o) {
    return t.indexOf(n.$el) - t.indexOf(o.$el);
  });
};
const St = "3.20.1";
var Tt = ft(O(O({}, l), {}, {
  isVue2: le
})), _t = vt(O(O({}, l), {}, {
  isVue2: le
})), B = "Tiny", mt = {
  tiny_mode: String,
  tiny_mode_root: Boolean,
  tiny_template: [Function, Object],
  tiny_renderless: Function,
  tiny_theme: String,
  tiny_chart_theme: Object
}, gt = ["tiny_mode", "tiny_mode_root", "tiny_template", "tiny_renderless", "_constants", "tiny_theme", "tiny_chart_theme"], Y = function(e, t) {
  var n = function(v) {
    return ~["pc", "mobile", "mobile-first"].indexOf(v);
  }, o = Z(t), r = typeof e.tiny_mode == "string" ? e.tiny_mode : null, a = l.inject("TinyMode", null), u;
  typeof o.tiny_mode == "string" ? u = o.tiny_mode : o.tiny_mode && (u = o.tiny_mode.value), n(r) || (r = null), n(a) || (a = null), n(u) || (u = null);
  var c = r || a || u || "pc";
  e.tiny_mode_root && l.provide("TinyMode", c);
  var s = l.getCurrentInstance();
  return Object.defineProperty(s, "_tiny_mode", {
    value: c
  }), c;
}, yt = function(e, t) {
  var n = function(f) {
    return ~["tiny", "saas"].indexOf(f);
  }, o = Z(t), r = typeof e.tiny_theme == "string" ? e.tiny_theme : null, a = l.inject("TinyTheme", null), u = o.tiny_theme && o.tiny_theme.value;
  n(r) || (r = null), n(a) || (a = null), n(u) || (u = null);
  var c = r || a || u || "tiny";
  return c;
}, ht = function(e, t) {
  var n = Z(t), o = S(e.tiny_chart_theme) === "object" ? e.tiny_chart_theme : null, r = l.inject("TinyChartTheme", null), a = n.tiny_chart_theme && n.tiny_chart_theme.value, u = o || r || a || null;
  return u;
}, bt = function(e) {
  var t = e.props, n = e.context, o = e.template, r = e.extend, a = r === void 0 ? {} : r, u = Y(t, n), c = l.computed(function() {
    if (typeof t.tiny_template < "u")
      return t.tiny_template;
    var s = o(u, t);
    return typeof s == "function" ? oe(s) : s;
  });
  return ae({
    view: c,
    props: t,
    context: n,
    extend: a
  });
}, N = {
  configKey: Symbol("designConfigKey"),
  configInstance: null
}, Mt = function(e) {
  Object.keys(e).length && (l.provide(N.configKey, e), N.configInstance = e);
}, Ct = Je(N), pe = {
  designConfig: null,
  twMerge: function() {
    return "";
  }
}, q = function() {
  for (var e = arguments.length, t = new Array(e), n = 0; n < e; n++)
    t[n] = arguments[n];
  return pe.twMerge(D(t));
}, xt = function(e) {
  var t, n, o, r = e.props, a = e.context, u = e.renderless, c = e.api, s = e.extendOptions, f = s === void 0 ? {} : s, v = e.mono, h = v === void 0 ? !1 : v, p = e.classes, w = p === void 0 ? {} : p, $ = typeof r.tiny_renderless == "function" ? r.tiny_renderless : u, b = pe.designConfig || l.inject(N.configKey, {});
  b = ((t = b) === null || t === void 0 ? void 0 : t.value) || b || {};
  var d = (n = b) === null || n === void 0 || (o = n.components) === null || o === void 0 ? void 0 : o[Re().replace(B, "")], g = O(O({
    $prefix: B,
    t: X
  }, Ge(a, Y(r, a))), {}, {
    designConfig: d,
    globalDesignConfig: b,
    useBreakpoint: it,
    mergeClass: q
  });
  g.vm.theme = yt(r, a), g.vm.chartTheme = ht(r, a);
  var C = $(r, l, g, f);
  typeof (d == null ? void 0 : d.renderless) == "function" && Object.assign(C, d.renderless(r, l, g, C));
  var m = {
    t: X,
    vm: g.vm,
    f: Se,
    a: de,
    d: g.defineInstanceProperties,
    dp: g.defineParentInstanceProperties,
    gcls: function(x) {
      return _e(w, x);
    },
    m: q
  };
  return m.d({
    slots: {
      get: function() {
        return g.vm.$slots;
      },
      configurable: !0
    },
    scopedSlots: {
      get: function() {
        return g.vm.$scopedSlots;
      },
      configurable: !0
    }
  }), m.dp({
    slots: {
      get: function() {
        return g.parent.$slots;
      },
      configurable: !0
    },
    scopedSlots: {
      get: function() {
        return g.parent.$scopedSlots;
      },
      configurable: !0
    }
  }), me(), Array.isArray(c) && (Array.isArray(d == null ? void 0 : d.api) && (c = c.concat(d.api)), c.forEach(function(y) {
    var x = C[y];
    typeof x < "u" && (m[y] = x, h || g.setParentAttribute({
      name: y,
      value: x
    }));
  })), m;
};
function At(i) {
  var e = i.name, t = e === void 0 ? "Icon" : e, n = i.component;
  return function(o) {
    return Me(Xe({
      name: B + t,
      setup: function(a, u) {
        var c = u.attrs || {}, s = c.fill, f = c.width, v = c.height, h = c["custom-class"], p = c["first-color"], w = c["second-color"], $ = Object.assign({}, a, o || null), b = Y($, u), d = b === "mobile-first", g = {
          "data-tag": d ? "tiny-svg" : null
        }, C = g, m = "tiny-svg";
        d && (m = q("h-4 w-4 inline-block", h || "", $.class || ""));
        var y = Object.assign({
          style: {
            fill: s,
            width: f,
            height: v,
            "--tiny-first-color": p || "",
            "--tiny-second-color": w || ""
          },
          class: m,
          isSvg: !0
        }, C);
        if (y.nativeOn = u.listeners, ot.includes(t)) {
          var x = n.render;
          n.render = function() {
            for (var M = x.bind(this), j = arguments.length, A = new Array(j), P = 0; P < j; P++)
              A[P] = arguments[P];
            var T = M(A);
            return ct(T), T;
          };
        }
        return ae({
          component: n,
          props: $,
          context: u,
          extend: y
        });
      }
    }));
  };
}
var de = function(e, t, n) {
  var o = {}, r = function(c) {
    var s = t.some(function(f) {
      return new RegExp(f).test(c);
    });
    (n && s || !n && !s) && (o[c] = e[c]);
  };
  for (var a in e)
    r(a);
  return o;
}, L = {}, me = function() {
  for (var e in L) {
    var t = L[e];
    typeof t.install == "function" && t.install(ke()), typeof t.init == "function" && t.init(Ve());
  }
  L = {};
}, $t = function(e) {
  e.install = function(t) {
    t.component(e.name, e);
  };
};
const Rt = {
  h: Ye,
  directive: He,
  parseVnode: ze,
  isEmptyVnode: Qe,
  useRouter: ue,
  emitter: W,
  createComponent: Ct,
  defineAsyncComponent: oe,
  filterAttrs: de,
  initComponent: me,
  setupComponent: L,
  svg: At,
  $prefix: B,
  $props: mt,
  props: gt,
  $setup: bt,
  setup: xt,
  hooks: l,
  getElementStatusClass: Te,
  $install: $t,
  isVnode: et
};
export {
  $t as $install,
  B as $prefix,
  mt as $props,
  bt as $setup,
  jt as KeepAlive,
  wt as Teleport,
  Ve as appProperties,
  Ct as createComponent,
  pe as customDesignConfig,
  It as deduplicateCssClass,
  Rt as default,
  oe as defineAsyncComponent,
  Xe as defineComponent,
  N as design,
  He as directive,
  W as emitter,
  de as filterAttrs,
  Te as getElementStatusClass,
  Ye as h,
  l as hooks,
  me as initComponent,
  Qe as isEmptyVnode,
  et as isVnode,
  le as isVue2,
  Ot as isVue3,
  q as mergeClass,
  ze as parseVnode,
  gt as props,
  Mt as provideDesignConfig,
  Y as resolveMode,
  yt as resolveTheme,
  xt as setup,
  L as setupComponent,
  D as stringifyCssClass,
  tt as stringifyCssClassArray,
  z as stringifyCssClassObject,
  At as svg,
  it as useBreakpoint,
  Et as useDefer,
  Tt as useInstanceSlots,
  _t as useRelation,
  ue as useRouter,
  St as version
};
